var firstUID; // userId of first group

// Init page
function init(){
	var items=[],e,win=dgi('winLogin'),pwdIco;
	wl.setKeycodeListener(dgi('loginGroupInput'),groupInputKD)
	wl.setKeycodeListener(dgi('loginSubUserInput'),subUserInputKD)
	wl.setKeycodeListener(dgi('loginPasswordInput'),passwordInputKD,'onkeyup')

	// Generate group input context menu
	for(e in users) if(users[e]['name']){
		if(!firstUID) firstUID=e;
		pwdIco=(users[e]["password"])?wl.ico.lock:'/gfx/v.gif';
		if(users[e]["password"]==='facebook') pwdIco=wl.ico.facebook;
		items.push(ContextMenuItem(pwdIco,users[e]["name"],"javascript:setUserById('"+e+"')"));
	}
	ContextMenuAttach(dgi('showUsersBt'),items,{'align':'right','leftClick':1,'button':dgi('loginGroupInput'),'style':{'width':dgi('loginGroupInput').offsetWidth}})

	// Set a default user if none is set
	if(!dgi('loginGroupInput').value && firstUID) {setUserById(firstUID,{'noFocus':1}); dgi('loginGroupInput').focus()}
	else setUserByName(dgi('loginGroupInput').value);

	// Popup anim or box resize
	var eP={
		'bl':dgi('winL').offsetWidth,
		'bb':dgi('winBTr').offsetHeight,
		'bt':dgi('winTTr').offsetHeight,
		'startX':0,
		'startY':0,
		'destX':win.style.marginLeft.replace(/px/,''),
		'destW':win.offsetWidth,
		'destH':dgi('winLogin_oif').offsetHeight
	};
	eP.destH+=eP.bb+eP.bt;
	eP.destY=-eP.destH/2;

	if(1&&windowsAnimation){
		wl.anim({'item':win,'duration':1000,'callbackComplete':null,'eP':eP,'function':
		function(p,anim){
			p=wl.animFunctionUnfold2(p,anim);
			anim.item.opacity=p;
			if(p==1 && (phpBrowser=='ie'||phpBrowser=='ie+'||phpBrowser=='opera')) h='auto';
			else h=Math.max(0,(eP.destH*p))+'px'

			// don't return any css properties to anim function as all resizes/moves have already been done
			return {'marginLeft':(eP.startX+p*(eP.destX-eP.startX))+'px','marginTop':(eP.startY+p*(eP.destY-eP.startY))+'px','width':Math.max(0,(eP.destW*p))+'px','height':h};
		}});
	}
	else{
		//dgi('winLogin_oif').style.height=(eP.destH-eP.bt-eP.bb)+'px'

		if(phpBrowser=='ie'||phpBrowser=='ie+'||phpBrowser=='opera') win.style.height='auto';
		else win.style.height=(eP.destH)+'px';
	}
}

/**
 * Key down management (enter, arrow up, arrow down) on group input
 */
function groupInputKD(kc,n,e){
	// Enter key
	if(kc==13 && n.value) {
		if(dgi('loginPasswordInput').disabled) login(); else dgi('loginPasswordInput').focus();
	}
	// Arrow up or down
	if(kc==38 || kc==40){
		if(!selectedUserId||selectedUserId==-1) setUserById(firstUID);
		else{
			// Find previous and next groups
			var p=0,n=0;
			for(e in users) {
				if(!n && (!p || e!=selectedUserId)) p=e;
				if(e==selectedUserId) n=selectedUserId;
				else if(n){
					n=e;
					break;
				}
			}
			setUserById((kc==38)?p:n,{'noFocus':1});
		}
		return false;
	}
	else if(kc>40) setUserByName(dgi('loginGroupInput').value);
}

// subUser input key down management
function subUserInputKD(kc,n,e){if(kc==13 && n.value) dgi('loginPasswordInput').focus()}

// Password input key down management
function passwordInputKD(kc,n,e){if(kc==13 && n.value) login()}

function resetInputs(){
	if(dgi("encryptionLockSend")) dgi("encryptionLockSend").style.display="none";
	dgi("loginPasswordInput").value="";
	loginSetError();
}
// Set error message, false to hide
function loginSetError(txt){
	dgi('loginError').innerHTML=txt;
	dgi('loginError').style.display=(txt)?'':'none';
	dgi('loginHint').style.display=(txt)?'none':'';
}

// Set user hint, false to hide
function loginSetHint(userId){
	dgi('loginError').style.display='none';
	with(dgi('loginHint').style) {
		display='';
		visibility=(userId && users[userId]['hint'])?'visible':'hidden';
	}
	dgi('loginHintCapt').innerHTML=(userId&&users[userId]['hint'])?users[userId]['hint']:'-';
}

// Check all fields are OK and post login form
function login(){
	// If no user typed, abort
	if(!dgi('loginGroupInput').value) dgi('loginGroupInput').focus();
	// If selected group needs a password and no password is entered, abort (and focus)
	else if(selectedUserId!==-1 && users[selectedUserId]['password']===1 && !dgi('loginPasswordInput').value) dgi('loginPasswordInput').focus();
	// If selected group needs a subUser and no subUser is entered, abort (and focus)
	else if(selectedUserId!==-1 && users[selectedUserId]['password']==="list" && !dgi('loginSubUserInput').value) dgi('loginSubUserInput').focus();
	// Facebook login
	else if(selectedUserId!==-1 && users[selectedUserId]['password']==='facebook')	loginFacebook(selectedUserId);
	// Proceed
	else{
		// Remove password if no password needed for selected group
		if(dgi("loginPasswordInput").disabled) dgi("loginPasswordInput").value='';
		// Log by group id + subUser (+ password)
		if(users[selectedUserId] && users[selectedUserId]['password']==='list') logUserById(selectedUserId,dgi('loginSubUserInput').value+'*wSep*'+dgi('loginPasswordInput').value)
		// Log user by name
		else if(selectedUserId!==1) logUserByName(dgi('loginGroupInput').value,dgi('loginPasswordInput').value);
		// Log user by Id
		else logUserById(users[selectedUserId]['id'],((users[selectedUserId]['password'])?dgi('loginPasswordInput').value:false))
	}
}

// Set user stuff from a given uid
function setUserById(u,opt){
	if(!opt) opt={};
	selectedUserId=u;
	dgi("loginGroupInput").value=users[u]['name'];
	var p=$("loginPasswordInput"),bp=$("loginPasswordOuterFrame"), hasPassword=!(users[u]['password']===0||users[u]['password']==='facebook');
	p.disabled=!hasPassword;
	bp.e.setAlpha((hasPassword)?1:0.5);
	subUserEnable(users[u]['password']=='list');
	loginSetHint(u);

	// Focus on subUser or password
	if(opt.noFocus) return;
	if(users[u]['password']=='list' && !dgi('loginSubUserInput').value) setTimeout('dgi("loginSubUserInput").focus()',10);
	else if(!p.disabled) setTimeout('dgi("loginPasswordInput").focus()',10);
}
// Set user stuff from a given name
function setUserByName(name){
	if(!name) return;
	for(var e in users) if(users[e]['name']===name) return setUserById(e);
	dgi("loginPasswordInput").disabled=false;
	subUserEnable(0);

	selectedUserId=-1;
	loginSetHint();
}

// Enable / disable subUser input
function subUserEnable(enable){
	$('loginSubUserGroup').e.setAlpha((enable)?1:0.5)
	$('loginSubUserInput').disabled=!enable
}