<?php
require_once(INCLUDE_DIR.'outputFunctions.php');
require_once(INCLUDE_DIR.'framesFunctions.php');


/**
 * @desc Insert HTML code for bottom menu bar
 *
 */
function displayWinBar(){
	echo '<div id="winBarOuter" class="menuFrameBody" onResize="menuWinBarResized()" style="overflow:hidden;position:absolute;height:29px;width:100%;left:0;bottom:0">';
	echo outTableTransparent("menuBar",'margin-top:2px');
	echo '<colgroup><col width="80"><col width="*"><col width="80"></colgroup>';
	echo "<tr><td style='width:80px;display:block'>\n";

	echo "</td><td id='winOpenedOuter' style='white-space:nowrap'>\n";
	// tasks bar
	fInsertWindowsBar('150px');
	echo '</td><td id="timeDiv" style="padding-top:3px;display:block;position:relative">';

	// Async request indicator
	echo outImage(outIcon('onSmall'),false,'id="asyncRequestIndicator"','position:absolute;left:-20px;top:4px;visibility:hidden');

	// Logout button
	echo outButtonSmall('','javascript:logout();',outIcon('off'),cfCaption('genLogout'),false,'style="vertical-align:middle"');
	// Hour/min/sec clock javascript
	fInsertClock(true);
	echo "</td></table>\n";
	echo "</div>\n";
	// Menu button
	echo outImage(cfAppThemeDir(true).'/menuBt.png',false,'id="menuBt" title="'.cfCaption('genMenu').'" onclick="javascript:menuToggle()" onmouseover="menuBtHover()" onmouseout="menuBtOut()"','position:absolute;bottom:-6px;left:10px;cursor:pointer;z-index:99990');
}

/**
 * XP-Style menu
 */
function displayMenu(){
	global $resources;
	global $resourcesObjects;

	echo '<div id="menu" style="position:absolute;width:460px;bottom:0;left:-800px;width:200;z-index:99989">';

	// Top GFX
	echo '<div class="menuTop"></div>';

	// Menu "white" frame
	echo '<div class="menuInnerDiv" style="filter:Alpha(opacity=90,style=0)">';

	// Grouping
	$types=array('administration'=>cfCaption('resAdministration'), 'explorer'=>cfCaption('resExplorer'), 'webcam'=>cfCaption('resWebcam'), 'website'=>cfCaption('resWebsite'), 'blog'=>cfCaption('resBlog'), 'bookmarks'=>cfCaption('resBookmarks'), 'tv'=>cfCaption('resTv'), 'misc'=>cfCaption('resMisc'));
	$i=0;
	echo '<div id="menuItemsDiv" '.outEHoverFrameAttr().'>';

	// Group by resource type
	foreach ($types as $type=>$caption){
		$output='';
		// Foreach resource of group
		foreach($resources as $value) if(isset($value['type']) && $value['type']==$type){
			// Hover / link div
			$output.='<div id="menu_'.$i.'" class="menuLarge" eH=1 onclick="javascript:menuHide();'.$value['resourceJsLink'].'">';
			// Resource icon
			$output.='<img alt="" src="'.($resourcesObjects[$value['id']]->icon16()).'">';
			// Name
			$output.=cfUTF8Encode($value['name']).'</div>';
			$i++;
		}
		if($output) {
			echo '<div class="menuGroup"><span style="background:white">'.$caption.' &nbsp;</span></div>'.$output;
			$i++;
		}
	}
	for(;$i<14;$i++) echo '<br>';
	echo "</div>\n";
	echo "</div>\n"; // end of menuInnerDiv

	// Bottom gfx
	echo '<div class="menuBottom"></div>';

	// User icon
	echo '<img style="position:absolute;top:10px;left:303px;'.outCssOpacity(65).'" src="'.cfAppThemeDir('true').'/menuUserFrame.gif" alt="">';
	echo '<img style="position:absolute;top:17px;left:310px;'.outCssOpacity(90).'" src="/gfx/icons/'.cfUGetVar('icon').'" alt="">';

	// User name
	echo '<div style="position:absolute;top:112px;left:260px;width:180px;text-align:center;color:white;font-size:16px">'.cfUTF8Encode(cfUGetVar('name')).'</div>';

	// Top separator
	echo '<div style="position:absolute;top:140px;left:280px;width:150px;height:0px;line-height:0px;border-top:1px solid #222; border-bottom:1px solid #777"></div>';

	// Configuration
	echo outBt('&nbsp;&nbsp;&nbsp;'.cfCaption('mainConfigButton'),outIcon('config3'),'javascript:menuHide();'.fConfigLink(),false, false,'style="position:absolute; bottom:90;left:265px"','up','160px');


	// Bottom separator
	echo '<div style="position:absolute;bottom:75px;left:280px;width:150px;height:0px;line-height:0px;border-top:1px solid #222; border-bottom:1px solid #777"></div>';

	// Theme selection control
	if(cfGGetVar('allowUserThemeChange')) echo '<div id="themeControl" style="position:absolute;left:270px;bottom:45px; width:200px;text-align:left;">'.outThemeSelectionControl('user',true,'GET', 'onmouseover="doCancelSelection=false;" onmouseout="doCancelSelection=true;"').'</div>';

	// Logout icon
	echo outBt('&nbsp;&nbsp;&nbsp;'.cfCaption('genLogout'),outIcon('logout'),'javascript:logout();',false, false,'style="position:absolute; bottom:10px;left:265px"','up','160px');

	// End of menu
	echo "</div>\n";
}

?>
<script language="javascript" type="text/javascript">
var iconWidth=70, iconHeight=70, menuShown=0;
var cimg=new Image();cimg.src="<?php echo cfAppThemeDir(true).'/menuBtH.png';?>";
// Send windows events to menu frame
function winMonitor(win,action){menuWin(action, win.id, win.getIcon(), win.getCaption());}

</script>
<?php
// Insert menu javascript and background mask
fInsertMenuStuff(2,1);


echo '<span style="color:white; position:absolute;top:7px; right:30px;cursor:pointer" onclick="creditsPopup()">Weezo&nbsp;'.outImage(outIcon('logoSmall'),false,false,'vertical-align:middle; margin-left:0.5em').'</span>';

// Set default wallpaper
if(!$wallpaper) {$wallpaper=cfAppThemeDir(true).'/bg.jpg'; $wallpaperPosition='stretched';}

displayWinBar();

// Display icons
$resources=cfResourcesGetUser();
addIcons($resources);

// Display menu
displayMenu();


// Resize XP-style menu resource frame so it's not higher than screen
?>
<script type="text/javascript">
if(dgi('menuItemsDiv')) {
	var h=(W.innerHeight)?W.innerHeight-65:D.body.offsetHeight-40;
	if(dgi('menuItemsDiv').offsetHeight>h) dgi('menuItemsDiv').style.height=(h)+'px';
}
</script>