<?php
/**
 * Simple / normal mode selection form
 *
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.1.0K
 */

//if(!cfIsInApp()) die('unauthorized access');

require_once(INCLUDE_DIR.'outputFunctions.php');

if(cfIsAsync()){
	echo cfAsyncHeader();
	if(isset($_POST['setMode']) && ($_POST['setMode']==='simple' || $_POST['setMode']==='normal')){

		cfGUpdateVar('simpleMode',$_POST['setMode']==='simple');
		if($_POST['setMode']==='simple'){
			cfGUpdateVar('selectedTab','resource');
			echo cfAsyncJSaction("wl.UICommand('selectPanel:resource/share')");
		}
		echo cfAsyncJSaction("wl.UICommand('close:".$_POST['setMode']."')");
	}
	die(cfAsyncFooter());
}

/**
 ***************************************************************************************************************************
 * Insert page HEADER
 ***************************************************************************************************************************
 */
cfInsertHEAD(true,array('size'=>'400x228','closable'=>'false'));
echo "<body>\n";
echo outDivFrame('frame1');

$simple=outImage(outIcon('modeSimple'),false,false,'float:left;margin: 10px 10px 0 0');
$simple.='<div class="frame1Header" style="font-size:240%">'.cfCaption('simpleMode').'</div>';
$simple.='<span style="font-size:140%">'.cfCaption('simpleModeDet').'</span>';

$normal=outImage(outIcon('modeAdvanced'),false,false,'float:left;margin: 10px 24px 10px 14px');
$normal.='<div class="frame1Header" style="font-size:180%">'.cfCaption('normalMode').'</div>';
$normal.='<span style="font-size:100%">'.cfCaption('normalModeDet').'</span>';

echo outBlockItem('mode',$simple,false,'width:100%;padding:10px',array('onclick'=>'setSimpleMode()'));
echo outBlockItem('mode',$normal,false,'width:100%;padding:10px',array('onclick'=>'setNormalMode()'));
echo '</div>';
?>
<script type="text/javascript">
function setSimpleMode(){wl.asr.send({'setMode':'simple'});}
function setNormalMode(){wl.asr.send({'setMode':'normal'});}
</script>